-----------------------------------------------------------
--
-- a nfib with the Haskell interface
-- Optionally with Eden extension.
--
--  Parameters: <program>  <n to calculate>
--
-- Purpose: test Maple interface.
--
-- Please, take care of lazyness on IO() if you are a newbie
-- at functional programming ( as I was while developing
-- this case)
--
-- If you don't require the rnf some times your program
-- may not run as expected, seeming the interace to be blocked.
-- This is specially need for every constructor
-- involving a MapleObject inside,ie:
-- data fooType = FooCons MapleObject | Nil
-- The whnf (weak head normal form), will stop when closure reachs FooCons 
-- Then, after shutting down the interface (mapleTerm...), if some IO()  
-- requires normal form for the type, the pipes, maple server, will be
-- no longer available, and your program will block.
--
-- You should force the rnf, using Strategies.
--
-- If you don't know what I'm talking about,
-- just force the normal form by making print the object
-- In case of trouble, for a better understanding on this,
-- take a look into /tmp/debug
-----------------------------------------------------------

module Main where
import System(getArgs)
import IO
import Strategies
#ifdef _EDEN_
import Eden
#endif
import MapleAPI


main    =  do args <- getArgs
              let n     =  read (args!!0) :: Int
#ifdef _EDEN_
              a <- mapleInitAllDream
	      print (process mapleFibonacci # n) 
              b <- mapleTermAllDream  
#else
	      mapleInit
	      print (mapleFibonacci n)
	      mapleTerm
#endif 
	      return () 

--
-- Implicit concurrency:
-- Eden RTS will use two threads, one per each element on the output tuple
-- Don't worry: the interface prevents you from concurrency issues.
--
mapleFibonacci :: Int -> (Integer,Integer)
mapleFibonacci n =(a , b)
	       where a =  mapleObject2Integer (mapleEval "fibonacci" [int2MapleObject n])
                     b =  mapleObject2Integer (mapleEval "fibonacci" [int2MapleObject (n+4)])
